//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
	TOpenDialog *OpenDialogImport;
	TSaveDialog *SaveDialogExport;
	TPanel *PanelMapView;
	TScrollBox *ScrollBoxMap;
	TImage *ImageMap;
	TPanel *PanelTools;
	TLabel *LabelInfo;
	TComboBox *ComboBoxSize;
	TImage *ImageTileA;
	TSplitter *SplitterMap;
	TSpeedButton *SpeedButtonMap2x;
	TSpeedButton *SpeedButtonMap3x;
	TSpeedButton *SpeedButtonMap4x;
	TSpeedButton *SpeedButtonTileset2x;
	TSpeedButton *SpeedButtonTileset3x;
	TSpeedButton *SpeedButtonTileset4x;
	TSpeedButton *SpeedButtonImport;
	TSpeedButton *SpeedButtonExport;
	TSpeedButton *SpeedButtonReplaceAB;
	TScrollBox *ScrollBoxTileset;
	TImage *ImageTileset;
	TLabel *Label1;
	TLabel *Label2;
	TImage *ImageTileB;
	TShape *ShapeA;
	TShape *ShapeB;
	TSpeedButton *SpeedButtonReplaceBA;
	TLabel *LabelInfoTileA;
	TLabel *LabelInfoTileB;
	TSpeedButton *SpeedButtonTileACursor;
	TSpeedButton *SpeedButtonTileASolo;
	TSpeedButton *SpeedButtonTileANone;
	TSpeedButton *SpeedButtonTileBCursor;
	TSpeedButton *SpeedButtonTileBSolo;
	TSpeedButton *SpeedButtonTileBNone;
	TColorDialog *ColorDialogCursor;
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall ImageTilesetMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageMapMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall CheckBoxShowSelectedClick(TObject *Sender);
	void __fastcall ComboBoxSizeChange(TObject *Sender);
	void __fastcall ImageMapMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall ImageTilesetMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageTileAMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageTileAMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall ImageTileAMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SpeedButtonMap2xClick(TObject *Sender);
	void __fastcall SpeedButtonTileset2xClick(TObject *Sender);
	void __fastcall SpeedButtonImportClick(TObject *Sender);
	void __fastcall SpeedButtonExportClick(TObject *Sender);
	void __fastcall SpeedButtonReplaceABClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall SpeedButtonTileACursorClick(TObject *Sender);
	void __fastcall ShapeAMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
public:		// User declarations
	__fastcall TFormMain(TComponent* Owner);

	void __fastcall TilesetToMap(bool cursor,bool repaint);
	void __fastcall MapToTileset(void);
	void __fastcall RenderTileset(void);
	void __fastcall RenderTile(TImage *image,int tile);
	void __fastcall TilesetFreqSort(void);
	void __fastcall UpdateInfo(void);
	void __fastcall ChangeTile(int &cursor,int tile);
	void __fastcall UpdateCursorColors(TImage *image);
	void __fastcall UpdateAll(void);
	void __fastcall ImportBMP(AnsiString filename);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
